import CamelElement from "../CamelElement";
import { Resources } from "../../utility";
class Rollback extends CamelElement {
  constructor() {
    super();
    this.scope = "Rollback";
    this.parent = "";
    this.inputid = ""; // 线的接入
    this.outputid = ""; // 线的出口
    this.id = "_rollback";
    this.description = "";
    this.markRollbackOnly = false;
    this.markRollbackOnlyLast = false;
    this.message = "";
  }

  paint(g) {
    if (this._img == null) {
      this._img = Resources.IMG_START_NODE;
    }

    g.save();
    this.color = "#cebee1";
    g.drawOvalBorder(this.x, this.y, this.width, this.height, 10, this.color);
    g.drawImage(this._img, this.x + 10, this.y + 5, this.icon_width / 2, this.icon_height / 2);
    g.setColor(Resources.COLOR.black);
    g.drawText("Rollback" + this.message, this.x + this.width / 6, this.y + this.height / 1.5);
    g.restore();
  }

  toXML() {
    let str = "";
    str += `<rollback id="${this.id}" x="${this.x}" y="${this.y}" scope="${this.scope}" description="${this.description}" markRollbackOnly="${this.markRollbackOnly}" markRollbackOnlyLast="${this.markRollbackOnlyLast}" message="${this.message}">\n <description>${this.description}</description>\n </rollback>\n`;
    return str;
  }

  parseXML(xmlNode) {}

  getPropsDesc() {
    return {
      details: ["id", "description", "markRollbackOnly", "markRollbackOnlyLast", "message"],
    };
  }
}
export default Rollback;
