import CamelElement from "../CamelElement";
import { Resources } from "../../utility";
class Marshal extends CamelElement {
  constructor() {
    super();
    this.scope = "Marshal";
    this.parent = "";
    this.inputid = ""; // 线的接入
    this.outputid = ""; // 线的出口
    this.id = "_marshal";
    this.description = "";
    this.dataFormatType = "";
    this.ref_deprecated = ""; // 已弃用(ref)
  }

  paint(g) {
    if (this._img == null) {
      this._img = Resources.IMG_START_NODE;
    }

    g.save();
    this.color = "#cebee1";
    g.drawOvalBorder(this.x, this.y, this.width, this.height, 10, this.color);
    g.drawImage(this._img, this.x + 10, this.y + 5, this.icon_width / 2, this.icon_height / 2);
    g.setColor(Resources.COLOR.black);
    g.drawText("Marshal" + this.id, this.x + this.width / 6, this.y + this.height / 1.5);
    g.restore();
  }

  toXML() {
    let str = "";
    str += `<marshal id="${this.id}" x="${this.x}" y="${this.y}" scope="${this.scope}" description="${this.description}" dataFormatType="${this.dataFormatType}" ref="${this.ref_deprecated}">\n <${this.dataFormatType}></${this.dataFormatType}>\n <description>${this.description}</description>\n </marshal>\n`;
    return str;
  }

  parseXML(xmlNode) {}

  getPropsDesc() {
    return {
      details: ["id", "description", "dataFormatType", "ref_deprecated"],
    };
  }
}
export default Marshal;
